﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
'VERSION:20220905
'By:eric19740521@gmail.com 可自行修改.並使用
'備註
'LIB:jdbc,jSQL
'mssql lib jdbcSQL需開啟

'MySQL
'#AdditionalJar: mysql-connector-java-5.1.47-bin.jar
'#AdditionalJar: mysql-connector-java-5.1.34-bin.jar
'MSSQL
'#AdditionalJar: jtds-1.3.1.jar		
'SQLite
'#AdditionalJar: sqlite-jdbc-3.7.2	
'firebird 2.5
'#AdditionalJar: jaybird-full-2.2.15.jar

#Region Project Attributes 
	'跳過未使用的提示!!!
	#IgnoreWarnings: 12
#End Region
Sub Class_Globals
	'Private fx As JFX
	
	'Public SQLDB As Object
	Public MySQL As SQL
	Public SQLite As SQL
	Public MSSQL As JdbcSQL		'特別用在mssql
	Public Firebird As SQL
	
	Private SQLDriver As String
	Private SQLJDBC As String
	'Public SQLServerIP As String 
	
	Public uc_DB_Type As String = "mySQL"
	Public uc_DB_SERVER As String = "127.0.0.1"
	Public uc_DB_Path As String = ""
	Public uc_DB_USER As String	= ""
	Public uc_DB_PASSWORD As String = ""
	
	Public LastError As String = ""
	
	Public Is_CollateNocase As Boolean = False
	
	'資料表欄位屬性
	Public DB_INTEGER,DB_NUMERIC   As String
	Public DB_CHAR As String 
	Public DB_BLOB,DB_REAL,DB_TEXT As String
	
	
	'
	Private TableFields As List
	Private TableWheres As List
	Private SQLCommands As List
	
	Public TableName As String 
	Public CommandType As String
	Public PrimaryKey As String
	
	'
	Public DBResultSet As ResultSet
	
	
	'
	Type FieldAttributes (fieldName As String,fieldType As String,fieldWidth As Int,fieldDec As Int)
	Type FieldAttributesN (fieldName As String,fieldValue As String,fieldType As String)

	Type SQLCommand (Command As String, Parameters() As Object)
	
	Type MyTrigger (TriggerName As String, TriggerContent As String)
	'procedure
	Type MyProcedure (ProcedureName As String, ProcedureContent As String)
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	'
	SQLDriver = "com.mysql.jdbc.Driver"
	SQLJDBC = "jdbc:mysql://"
	
	'
	DB_INTEGER = "INTEGER"
	DB_NUMERIC = "NUMERIC"

	DB_CHAR = "CHAR"
	
	DB_REAL = "REAL"
	DB_BLOB = "BLOB"
	DB_TEXT = "TEXT"
	
	'資料表欄位 列表
	TableFields.Initialize
	TableWheres.Initialize
	SQLCommands.Initialize
	
	TableName = ""
	CommandType = ""
	PrimaryKey = ""
End Sub

Sub Close
	
	Select uc_DB_Type.ToUpperCase
		Case "MYSQL"
			MySQL.Close
		
		Case "MSSQL"
			MSSQL.Close

		Case "SQLITE"
			SQLite.Close
	
		Case "FIREBIRD"
			Firebird.Close
	
			
		Case Else
			Log("close.err")
	End Select
	'SQLDB.close
	
End Sub


Sub Connect(tc_DATABASE As String) As Boolean
	Dim jdbcUrl As String
	
	'連線到資料庫
	Try
		Log("uc_DB_Type= "&uc_DB_Type)
		Select uc_DB_Type.ToUpperCase
			Case "MYSQL"
			
				SQLDriver = "com.mysql.jdbc.Driver"
				SQLJDBC = "jdbc:mysql://"
			
			
				jdbcUrl =  SQLJDBC & $"${uc_DB_SERVER}:3306/${tc_DATABASE}?characterEncoding=utf8"$

				MySQL.Initialize2( SQLDriver, jdbcUrl , uc_DB_USER , uc_DB_PASSWORD)

	
				If MySQL.IsInitialized = False Then
					LastError = "connect fail"
					Return False
				End If
	
	
	
			Case "MSSQL"
				 

				SQLDriver = "net.sourceforge.jtds.jdbc.Driver"
				jdbcUrl = $"jdbc:jtds:sqlserver://${uc_DB_SERVER}"$

				'MSQL 7.0
				'jdbcUrl = jdbcUrl & $";databaseName=${tc_DATABASE};user=${uc_DB_USER};password=${uc_DB_PASSWORD};appname=SKMJL;wsid=TEST;loginTimeout=10;socketTimeout=10"$
				'MSSQL SQLEXPRESS 2019
				jdbcUrl = jdbcUrl & $"/${tc_DATABASE};instance=SQLEXPRESS;user=${uc_DB_USER};password=${uc_DB_PASSWORD};integratedSecurity=true;"$
				
				
				'
				'jdbcUrl="jdbc:jtds:sqlserver://127.0.0.1/tudou;integratedSecurity=true;user=sa;password=Ho123456789;instance=SQLEXPRESS;"
				
				Log("jdbcUrl= "&jdbcUrl )
				'sql.Initialize("net.sourceforge.jtds.jdbc.Driver", "jdbc:jtds:sqlserver://localhost:1433/test;instance=SQLEXPRESS;?user=test&password=test")

				
				MSSQL.Initialize( SQLDriver, jdbcUrl  )
				
				If MSSQL.IsInitialized = False Then
					LastError = "connect fail"
					Return False
				End If
				
 
	
			Case "SQLite".ToUpperCase
				 
				Dim dbName As String = tc_DATABASE & ".db"
				'檢查資料庫檔案是否存在
				If File.Exists(uc_DB_Path, dbName)==False Then
					Log("DB不存在??程式將自動建立 ")
				End If
				
				Log("uc_DB_Path= "&uc_DB_Path)
				
				SQLite.InitializeSQLite(uc_DB_Path, dbName, True)
				SQLite.ExecQuerySingleResult("PRAGMA journal_mode = wal")
	
				If SQLite.IsInitialized = False Then
					LastError = "connect fail"
					Return False
				End If
				
			Case "FIREBIRD"
				'"jdbc:firebirdsql://127.0.0.1:3050/d:/NEWPOS.GDB"
				SQLDriver = "org.firebirdsql.jdbc.FBDriver"
				SQLJDBC = "jdbc:firebirdsql://"
			
			
				jdbcUrl =  SQLJDBC & $"${uc_DB_SERVER}:3050/${tc_DATABASE}"$

				Firebird.Initialize2( SQLDriver, jdbcUrl , uc_DB_USER , uc_DB_PASSWORD)

	
				If Firebird.IsInitialized = False Then
					LastError = "connect fail"
					Return False
				End If
								

			Case Else
				Log("uc_DB_Type.err")
				Return False
		End Select
	
	Catch
		'Log(LastException)
		'Log("sql錯誤: "&LastException)
		LastError = LastException
		Return False
	End Try
	
	
 
	
	Return True
End Sub



Sub SelectDB(tc_DATABASE As String) As Boolean
	'
	Select uc_DB_Type.ToUpperCase
		Case "MYSQL"
			MySQL.Close
		
		Case "MSSQL"
			MSSQL.Close
			
		Case Else
			Log("err")
	End Select
	'
	Return Connect(tc_DATABASE)
End Sub

Sub CreateDB(tc_DATABASE As String) As Boolean
	'建立資料庫
	Try
		Dim SQLQuery As String = $"CREATE DATABASE IF NOT EXISTS ${tc_DATABASE} CHARACTER SET = utf8 COLLATE = utf8_unicode_ci;"$
		
		MySQL.ExecNonQuery(SQLQuery)
		
		Log("建立資料庫成功~~")
	Catch
		'Log("mysql錯誤: "&LastException)
		LastError = LastException
		Return False
	End Try
	
	
	Return True
End Sub

Sub CreateTableStructure(tc_Table As String) As String
	

	Dim lc_SQLStructure As String = ""
	 
	Select uc_DB_Type.ToUpperCase
		
		Case "MYSQL"
			lc_SQLStructure=CreateTableStructure01(tc_Table)
		
		Case "MSSQL"
			lc_SQLStructure=CreateTableStructure02(tc_Table)
		Case "SQLITE"
			lc_SQLStructure=CreateTableStructure03(tc_Table)
		Case Else
			Log("err")
	End Select

	Return lc_SQLStructure
	
End Sub


'mySQL
private Sub CreateTableStructure01(tc_Table As String) As String
	Dim lc_SQLStructure As String = ""
	
	
	Dim lc_SQLStructure As String = ""
	Dim lc_str As String = ""
	
	'https://www.b4x.com/android/help/sql.html#sql_execquery 與範例不同
	Dim rs As ResultSet = MySQL.ExecQuery($" SHOW COLUMNS FROM ${tc_Table} "$)
	Do While rs.NextRow
		
		Dim fieldName As String
		Dim fieldType As String
		Dim fieldWidth As Int = 0
		Dim fieldDec As Int = 0
		Dim fieldCollateNocase As String = ""
		
		If Is_CollateNocase = True Then	'SQLite不分大小寫用
			fieldCollateNocase = "COLLATE NOCASE"
		End If
		
		fieldName = rs.GetString("field")
		fieldType = rs.GetString("type").Trim
		
		Dim s As String = ""
		
		
		'檢查是否有長度
		If rs.GetString("type").IndexOf("(")  > 0 Then
			'Log("111")
			
			fieldType = rs.GetString("type").SubString2(0,rs.GetString("type").IndexOf("(")).Trim
			
			'取得()裡面的字串
			s = rs.GetString("type").SubString2(rs.GetString("type").IndexOf("(")+1,rs.GetString("type").IndexOf(")"))
			
			'Log("t3")
			'檢查是否有小數點
			If s.IndexOf(",") > 0 Then
				fieldWidth = s.SubString2(0,s.IndexOf(","))
				
				fieldDec = s.SubString(s.IndexOf(",")+1)
			Else
				
				fieldWidth = s
			End If

		End If
		
		 
		Select fieldType.ToLowerCase
			Case "char","varchar","nvarchar"
				fieldType = "char"
				lc_str = lc_str & $" ${fieldName}  ${fieldType}(${fieldWidth}) DEFAULT ''  ${fieldCollateNocase}  ,"$ &CRLF
				'lc_sql = lc_sql & $" ${fieldName} ${fieldType} (${fieldWidth} ) DEFAULT '' "$ & " ," &CRLF
				
			Case "numeric","decimal"
				fieldType = "numeric"
				lc_str = lc_str & $" ${fieldName}  ${fieldType}(${fieldWidth},${fieldDec}) DEFAULT '0' ,"$ &CRLF

			Case "int","smallint","tinyint"
				fieldType = "int"
				'fieldWidth=Cursor.GetString("numeric_precision")
				fieldDec=0
			
				lc_str = lc_str & $" ${fieldName}  ${fieldType}(${fieldWidth}) DEFAULT '0' ,"$ &CRLF



			Case "datetime"
				lc_str = lc_str & $" ${fieldName}  ${fieldType}    ,"$ &CRLF
				 
				 
			Case "text"			'特別的欄位
				'fieldType = "char"
				fieldWidth = rs.GetString("character_maximum_length")
			
				lc_str = lc_str & $" ${fieldName} ${fieldType} (${fieldWidth} )   "$ & " ," &CRLF
				'Log($" ${fieldName} ${fieldType} (${fieldWidth} ) "$)
			
			Case "bit"			'特別的欄位
				fieldType = "char"
				'fieldWidth=Cursor.GetString("numeric_precision")
				fieldWidth=1
				
				lc_str = lc_str & $" ${fieldName} ${fieldType} (${fieldWidth} ) DEFAULT '' "$ & " ," &CRLF
				'Log($" ${fieldName} ${fieldType} (${fieldWidth} ) "$)
		
				 
				 
				 
			Case Else
				Log("未知的欄位名稱: "&fieldType)
		End Select
			
	 
		
		'lc_str = lc_str & $" ${fieldName}  ${fieldType} (${fieldWidth}) "$ &CRLF
		'Log(fieldName)
		'Log(fieldType)
		'Log(fieldWidth)
		'Log(fieldDec)
		'TextArea1.Text = TextArea1.Text & CRLF
	Loop
	
	Log("pk")
	'列出PK
	Dim lc_PK As String =""
	Dim rs As ResultSet = MySQL.ExecQuery($" SHOW COLUMNS FROM ${tc_Table} "$)

	Do While rs.NextRow
		
		 
		'Log(rs.GetString("name") &"-"& rs.Getstring("pk") )
		If rs.GetString("Key").Length > 0 Then
			lc_PK = lc_PK & rs.GetString("field") &","
		End If

	Loop

	If lc_PK.Length > 0 Then
		lc_PK = lc_PK.SubString2(0,lc_PK.Length-1)
		
		lc_PK = ", PRIMARY KEY (" & lc_PK &")"
	End If
	
 
	rs.Close
	
	If lc_str.Length > 0 Then
		lc_str = lc_str.SubString2(0,lc_str.Length-2 )
		
	End If
	
	lc_SQLStructure = $"
CREATE TABLE  ${tc_Table} (
${lc_str }
${lc_PK}
)  ;
	"$
	
		

	Return lc_SQLStructure
End Sub


'MSSQL
private Sub CreateTableStructure02(tc_Table As String) As String
	
	
	
	Dim lc_SQLStructure As String = ""
	
	'Dim lc_Table As String = "factory"
	
	'列出PK
	Dim lc_PK As String =""
	Dim CursorPK As JdbcResultSet
	
	'Log("list PK")
	'MSSQL7.0 select * From INFORMATION_SCHEMA.KEY_COLUMN_USAGE where table_name='"&tc_Table&"'
	'MSSQL2019 select * from INFORMATION_SCHEMA.COLUMNS where table_name='bank'
	CursorPK = MSSQL.ExecQuery("select * From INFORMATION_SCHEMA.KEY_COLUMN_USAGE where table_name='"&tc_Table&"' ")
	Do While CursorPK.NextRow
		
		'Log(CursorPK.GetString("column_name"))
		lc_PK = lc_PK & CursorPK.GetString("column_name") &","
	Loop

	If lc_PK.Length > 0 Then
		lc_PK = lc_PK.SubString2(0,lc_PK.Length-1)
		
		lc_PK = ", PRIMARY KEY (" & lc_PK &")"
	End If

	'Log("list columns")
	'列出欄位SELECT * FROM Information_Schema.COLUMNS where table_name='product' order by ordinal_position
	Dim lc_SQL As String = ""
	Dim Cursor As JdbcResultSet
	Cursor = MSSQL.ExecQuery("SELECT * FROM Information_Schema.COLUMNS where table_name='"&tc_Table&"' order by ordinal_position ")
	Do While Cursor.NextRow
		
		Dim fieldName As String
		Dim fieldType As String
		Dim fieldWidth As Int = 0
		Dim fieldDec As Int = 0
		Dim fieldCollateNocase As String = ""
		
		If Is_CollateNocase = True Then	'SQLite不分大小寫用
			fieldCollateNocase = "COLLATE NOCASE"
		End If
		
		fieldName = Cursor.GetString("column_name")
		fieldType = Cursor.GetString("data_type")
		
		 
		'
		Select fieldType
			Case "char","varchar","nvarchar"
				fieldType = "char"
				fieldWidth = Cursor.GetString("character_maximum_length")
			
				lc_SQL = lc_SQL & $" ${fieldName} ${fieldType} (${fieldWidth} ) DEFAULT '' ${fieldCollateNocase} "$ & " ," &CRLF
				'Log($" ${fieldName} ${fieldType} (${fieldWidth} ) "$)
				
			Case "datetime"
				'fieldType = "date"	'暫時用date
				fieldWidth=0
				fieldDec=0
				
				lc_SQL = lc_SQL & $" ${fieldName} ${fieldType}  "$ & " ," &CRLF
				'Log($" ${fieldName} ${fieldType}   "$)
			
			Case "numeric","decimal"
				fieldType = "numeric"
				fieldWidth=18	'Cursor.GetString("numeric_precision")
				fieldDec=Cursor.GetString("numeric_scale")
			
				lc_SQL = lc_SQL & $" ${fieldName} ${fieldType} (${fieldWidth},${fieldDec}) DEFAULT '0'   "$ & " ," &CRLF
				'Log($" ${fieldName} ${fieldType} (${fieldWidth},${fieldDec}) "$)

			Case "int","smallint","tinyint"
				fieldType = "int"
				fieldWidth=Cursor.GetString("numeric_precision")
				fieldDec=0
			
				lc_SQL = lc_SQL & $" ${fieldName} ${fieldType} (${fieldWidth}) DEFAULT '0'   "$ & " ," &CRLF
				'Log($" ${fieldName} ${fieldType} (${fieldWidth},${fieldDec}) "$)

			Case "text"			'特別的欄位
				'fieldType = "char"
				fieldWidth = Cursor.GetString("character_maximum_length")
			
				lc_SQL = lc_SQL & $" ${fieldName} ${fieldType} (${fieldWidth} )   "$ & " ," &CRLF
				'Log($" ${fieldName} ${fieldType} (${fieldWidth} ) "$)
			
			Case "bit"			'特別的欄位
				fieldType = "char"
				'fieldWidth=Cursor.GetString("numeric_precision")
				fieldWidth=1
				
				lc_SQL = lc_SQL & $" ${fieldName} ${fieldType} (${fieldWidth} ) DEFAULT '' "$ & " ," &CRLF
				'Log($" ${fieldName} ${fieldType} (${fieldWidth} ) "$)
		

			Case "image"		'特別的欄位
				fieldType = "BLOB"
				fieldWidth=Cursor.GetString("numeric_precision")
			
				lc_SQL = lc_SQL & $" ${fieldName} ${fieldType}    "$ & " ," &CRLF
				'Log($" ${fieldName} ${fieldType} (${fieldWidth} ) "$)


			
			Case Else
				Log($"err:${tc_Table},未知的欄位型態"$&fieldType)
		End Select
		
		
		
		'Log($" ${fieldName} ${fieldType} (${fieldWidth},${fieldDec}) "$)
		'Log(Cursor.GetInt("col2"))
	Loop
	
	Try
		If lc_SQL.Length > 0 Then
			lc_SQLStructure = $" CREATE TABLE ${tc_Table} (
			${lc_SQL.SubString2(0,lc_SQL.Length-3)  }
			${lc_PK}
		 );
		 "$

		End If
		
	Catch
		Log(LastException)
	End Try
	

	

	Return lc_SQLStructure
End Sub


'SQLite
private Sub CreateTableStructure03(tc_Table As String) As String
	Dim lc_SQLStructure As String = ""
	
	
	Dim lc_SQLStructure As String = ""
	Dim lc_str As String = ""
	
	'https://www.b4x.com/android/help/sql.html#sql_execquery 與範例不同
	Dim rs As ResultSet = SQLite.ExecQuery($"pragma table_info('${tc_Table}');"$)
	Do While rs.NextRow
		
		Dim fieldName As String
		Dim fieldType As String
		Dim fieldWidth As Int = 0
		Dim fieldDec As Int = 0
		Dim fieldCollateNocase As String = ""
		
		If Is_CollateNocase = True Then	'SQLite不分大小寫用
			fieldCollateNocase = "COLLATE NOCASE"
		End If
		
		
		
		fieldName = rs.GetString("name")
		fieldType = rs.GetString("type").Trim
		
		Dim s As String = ""
		
		
		'檢查是否有長度
		If rs.GetString("type").IndexOf("(")  > 0 Then
			'Log("111")
			
			fieldType = rs.GetString("type").SubString2(0,rs.GetString("type").IndexOf("(")).Trim
			
			'取得()裡面的字串
			s = rs.GetString("type").SubString2(rs.GetString("type").IndexOf("(")+1,rs.GetString("type").IndexOf(")"))
			
			'Log("t3")
			'檢查是否有小數點
			If s.IndexOf(",") > 0 Then
				fieldWidth = s.SubString2(0,s.IndexOf(","))
				
				fieldDec = s.SubString(s.IndexOf(",")+1)
			Else
				
				fieldWidth = s
			End If

		End If
		
		 
		Select fieldType.ToLowerCase
			Case "char"
				lc_str = lc_str & $" ${fieldName}  ${fieldType}(${fieldWidth}) DEFAULT '' ${fieldCollateNocase} ,"$ &CRLF
				'lc_sql = lc_sql & $" ${fieldName} ${fieldType} (${fieldWidth} ) DEFAULT '' "$ & " ," &CRLF
				
			Case "numeric","decimal"
				lc_str = lc_str & $" ${fieldName}  ${fieldType}(${fieldWidth},${fieldDec}) DEFAULT '0' ,"$ &CRLF

			Case "int","smallint","tinyint"
				'fieldWidth=Cursor.GetString("numeric_precision")
				fieldDec=0
			
				lc_str = lc_str & $" ${fieldName}  ${fieldType}(${fieldWidth}) DEFAULT '0' ,"$ &CRLF



			Case "datetime"
				lc_str = lc_str & $" ${fieldName}  ${fieldType}    ,"$ &CRLF
				 
			Case Else
				Log("未知的欄位名稱: "&fieldType)
		End Select
			
	 
		
		'lc_str = lc_str & $" ${fieldName}  ${fieldType} (${fieldWidth}) "$ &CRLF
		'Log(fieldName)
		'Log(fieldType)
		'Log(fieldWidth)
		'Log(fieldDec)
		'TextArea1.Text = TextArea1.Text & CRLF
	Loop
	
	'Log("pk")
	'列出PK
	Dim lc_PK As String =""
	Dim rs As ResultSet = SQLite.ExecQuery($"pragma table_info('${tc_Table}');"$)

	Do While rs.NextRow
		
		 
		'Log(rs.GetString("name") &"-"& rs.Getstring("pk") )
		If rs.GetInt("pk") > 0 Then
			lc_PK = lc_PK & rs.GetString("name") &","
		End If

	Loop

	If lc_PK.Length > 0 Then
		lc_PK = lc_PK.SubString2(0,lc_PK.Length-1)
		
		lc_PK = ", PRIMARY KEY (" & lc_PK &")"
	End If
	
 
	rs.Close
	
	If lc_str.Length > 0 Then
		lc_str = lc_str.SubString2(0,lc_str.Length-2 )
		
	End If
	
	lc_SQLStructure = $"
CREATE TABLE  ${tc_Table} (
${lc_str }
${lc_PK}
)  ;
	"$
	
		

	Return lc_SQLStructure
End Sub

public Sub GetTriggerFile(TriggerName As String) As String
	
	Dim t As MyTrigger
	
	t.Initialize
	t.TriggerName = TriggerName.Trim	'"ship_detail_insert"
	t.TriggerContent = File.ReadString(File.DirApp & "\trigger",TriggerName & ".txt")
	
	'TextArea1.Text = t.TriggerContent
	
	Return t.TriggerContent
End Sub

Public Sub CreateTrigger(TriggerName As String,TriggerContent As String) As Boolean
	
	Try
		MySQL.ExecNonQuery($"DROP TRIGGER IF EXISTS  ${TriggerName} ;"$)
		MySQL.ExecNonQuery(TriggerContent)
	Catch
		'Log(LastException)
		'Log("mysql錯誤: "&LastException)
		LastError = LastException
		Return False
	End Try
	
	Return True
End Sub

public Sub GetProcedureFile(ProcedureName As String) As String
	
	Dim t As MyProcedure
	
	t.Initialize
	t.ProcedureName = ProcedureName.Trim	'"ship_detail_insert"
	t.ProcedureContent = File.ReadString(File.DirApp & "\procedure",ProcedureName & ".txt")
	
	'TextArea1.Text = t.TriggerContent
	
	Return t.ProcedureContent
End Sub

Public Sub CreateProcedure(ProcedureName As String,ProcedureContent As String) As Boolean
	
	Try
		MySQL.ExecNonQuery($"DROP Procedure IF EXISTS  ${ProcedureName} ;"$)
		MySQL.ExecNonQuery(ProcedureContent)
	Catch
		'Log(LastException)
		'Log("mysql錯誤: "&LastException)
		LastError = LastException
		Return False
	End Try
	
	Return True
End Sub

Private Sub EscapeField(f As String) As String
	Return "[" & f & "]"
End Sub


public Sub ClearCommand()
	
	'資料表欄位 列表
	TableFields.Initialize
	TableWheres.Initialize
	SQLCommands.Initialize
	
	TableName = ""
	CommandType = ""
	PrimaryKey = ""
	
End Sub

'AddField 自己用,所以沒有嚴謹的錯誤判斷.
'db.AddField("mem_no",db.DB_CHAR,"10")
public Sub AddField(p1 As String,p2 As String,p3 As String)
	
 
	Select CommandType
		Case "CreateTable"
			Dim lc_fieldName ,lc_fieldType ,lc_fieldWidth As String
		
			lc_fieldName = p1
			lc_fieldType = p2
			lc_fieldWidth =p3
		
		
			Dim f As FieldAttributes
			f.Initialize
	
			Dim lc_fieldDec As Int = 0		'預設為0
			Dim lc_str As String = lc_fieldWidth

			If lc_str.IndexOf(",")>0 Then
				lc_fieldWidth = lc_str.SubString2(0,lc_str.IndexOf(","))
				lc_fieldDec = lc_str.SubString(lc_str.IndexOf(",")+1)
 
			End If

	
			'依照個別欄位屬性去做處裡
			Select lc_fieldType.ToUpperCase
				Case DB_CHAR
					f.fieldName = lc_fieldName
					f.fieldType = lc_fieldType
					f.fieldWidth = lc_fieldWidth
					f.fieldDec = 0
			
				Case DB_INTEGER,DB_NUMERIC
					If lc_fieldType.ToUpperCase = DB_INTEGER Then
						f.fieldName = lc_fieldName
						f.fieldType = lc_fieldType
						f.fieldWidth = lc_fieldWidth
						f.fieldDec = 0
					End If
					If lc_fieldType.ToUpperCase = DB_NUMERIC Then
						f.fieldName = lc_fieldName
						f.fieldType = lc_fieldType
						f.fieldWidth = lc_fieldWidth
						f.fieldDec = lc_fieldDec
					End If

				Case DB_TEXT
					f.fieldName = lc_fieldName
					f.fieldType = lc_fieldType
					f.fieldWidth = lc_fieldWidth
					f.fieldDec = 0

				Case DB_BLOB
					f.fieldName = lc_fieldName
					f.fieldType = lc_fieldType
					f.fieldWidth = lc_fieldWidth
					f.fieldDec = 0
			
				Case DB_REAL
					f.fieldName = lc_fieldName
					f.fieldType = lc_fieldType
					f.fieldWidth = lc_fieldWidth
					f.fieldDec = 0
			End Select
			'
			TableFields.Add(f)
			 
			 
			 
			 
		Case  "QUERY","INSERT","UPDATE","DELETE"
			Dim lc_fieldName ,lc_fieldType ,lc_fieldValue As String
		
			lc_fieldName = p1
			lc_fieldValue = p2
			lc_fieldType =p3
		
		
			Dim fan As FieldAttributesN
			fan.Initialize
		
			fan.fieldName = lc_fieldName
			fan.fieldValue = lc_fieldValue
			fan.fieldType = lc_fieldType
		
			'
			TableFields.Add(fan)


		Case Else
			Log("CommandType Err")
	End Select
			





End Sub

public Sub AddWhere(p1 As String,p2 As String,p3 As String)
	Dim lc_fieldName ,lc_fieldValue As String
		
	lc_fieldName = p1
	lc_fieldValue = p2
	
		
		
	Dim fan As FieldAttributesN
	fan.Initialize
	
	fan.fieldName = lc_fieldName
	fan.fieldValue = lc_fieldValue
	
	
	TableWheres.Add(fan)
End Sub


'SQLite特別欄位屬性
'REAL : 浮點數值。以 8 Bytes來存放IEEE浮點數。
'TEXT : 文字字串值。以資料庫的文字編碼方式：UTF-8, UTF-16BE, UTF-16LE來儲存資料。
'BLOB : 二進位大型物件(Binary Large OBject)。
 
Public Sub SQLBuilder() As String
	Log("DBConnect SQLBuilder==>")
	
	Dim lc_sqlCommand As String
	
	
	Select CommandType
		Case "CreateTable"
			lc_sqlCommand = SQLBuilder_CreateTable
			
		Case "DropTable"
			lc_sqlCommand = SQLBuilder_DropTable
			
		Case "INSERT"
			lc_sqlCommand = SQLBuilder_Insert

		Case "UPDATE"
			lc_sqlCommand = SQLBuilder_Update

		Case "DELETE"
			lc_sqlCommand = SQLBuilder_Delete
			
		Case "QUERY"
			lc_sqlCommand = SQLBuilder_Query
			
		Case Else
			Log("CommandType Err")
	End Select
	
	'資料表欄位 列表
	TableFields.Initialize
	TableWheres.Initialize
	'SQLCommands.Initialize
	
	TableName = ""
	CommandType = ""
	PrimaryKey = ""
	
	
	Log("SQLCommand: "&lc_sqlCommand)
	
	Return lc_sqlCommand
End Sub


private Sub SQLBuilder_DropTable() As String
	Dim lc_sqlCommand As String
	
	lc_sqlCommand = "DROP TABLE IF EXISTS " & EscapeField(TableName)

	Return lc_sqlCommand
End Sub


private Sub SQLBuilder_CreateTable() As String
	Dim sb As StringBuilder
	'
	sb.Initialize
	sb.Append("(")
	For i=0 To TableFields.Size-1
		Dim fieldName As String
		Dim fieldType As String
		Dim fieldWidth As Int = 0
		Dim fieldDec As Int = 0
		Dim fieldCollateNocase As String = ""
		
		If Is_CollateNocase = True Then	'SQLite不分大小寫用
			fieldCollateNocase = "COLLATE NOCASE"
		End If
		Dim f As FieldAttributes
		
		f.Initialize
		f=TableFields.Get(i)
		
		fieldName = f.fieldName
		fieldType = f.fieldType
		fieldWidth= f.fieldWidth
		fieldDec = f.fieldDec
		
'		Log("fieldName: "&fieldName)
'		Log("fieldType: "&fieldType)
'		Log("fieldWidth:"&fieldWidth)
'		Log("fieldDec: "&fieldDec)
		
		If i > 0 Then sb.Append(", ")
		
		'SQLite欄位屬性
		Select fieldType.ToLowerCase
			Case "char"
				sb.Append( $" ${fieldName}  ${fieldType}(${fieldWidth}) DEFAULT '' ${fieldCollateNocase} "$ )
				
			Case "numeric","decimal"
				sb.Append(  $" ${fieldName}  ${fieldType}(${fieldWidth},${fieldDec}) DEFAULT '0' "$ )

			Case "int","smallint","tinyint"
				fieldDec=0
				sb.Append(  $" ${fieldName}  ${fieldType}(${fieldWidth}) DEFAULT '0' "$ )

			Case "datetime"
				sb.Append(  $" ${fieldName}  ${fieldType}    "$ )
				
				'比較特別的欄位 real/text	/blob,我通常不會使用
			Case "real","text","blob"
				sb.Append(  $" ${fieldName}  ${fieldType}    "$ )
 		 
				 
				 
			Case Else
				Log("未知的欄位名稱: "&fieldType)
		End Select
		
		'PK
		If fieldName = PrimaryKey Then sb.Append(" PRIMARY KEY")
	Next
	sb.Append(")")
	
 
	
	Dim lc_sqlCommand As String
	lc_sqlCommand = "CREATE TABLE IF NOT EXISTS " & EscapeField(TableName) & " " & sb.ToString
		
	Return lc_sqlCommand
End Sub


private Sub SQLBuilder_Insert() As String
	Dim sb, columns, values As StringBuilder
	
	sb.Initialize
	columns.Initialize
	values.Initialize
	
	sb.Append("INSERT INTO [" & TableName & "] (")
	For i=0 To TableFields.Size-1
		Dim fieldName As String
		'Dim fieldType As String
		Dim fieldValue As String
		
		Dim fan As FieldAttributesN
		
		fan.Initialize
		fan=TableFields.Get(i)
		
		fieldName = fan.fieldName
		fieldValue = fan.fieldValue
		'fieldType = fan.fieldType
		
		If i > 0 Then
			columns.Append(", ")
			values.Append(", ")
		End If
		columns.Append(EscapeField(fieldName))
				
		values.Append($"'${fieldValue}'"$)
		
		
	Next
	sb.Append(columns.ToString)
	sb.Append(") VALUES (")
	sb.Append(values.ToString)
	sb.Append(")")
	
	
	
	Dim lc_sqlCommand As String
	
	lc_sqlCommand = sb.ToString

	Return lc_sqlCommand
End Sub


private Sub SQLBuilder_Update() As String
	Dim sb, columns, wheres As StringBuilder
	
	sb.Initialize
	columns.Initialize
	wheres.Initialize

	
	For i=0 To TableFields.Size-1
		'Log("1")
		
		Dim fieldName As String
		Dim fieldValue As String
		
		Dim fan As FieldAttributesN
		
		fan.Initialize
		fan=TableFields.Get(i)
		
		fieldName = fan.fieldName
		fieldValue = fan.fieldValue
		
		If i > 0 Then
			columns.Append(", ")
		End If
		' update member set mem_name='123'  where mem_no='a001'
		columns.Append(EscapeField(fieldName))
		columns.Append($"='${fieldValue}' "$ )
		
	Next
	
	
	For i=0 To TableWheres.Size-1
		'Log("2")
		
		Dim fieldName As String
		Dim fieldValue As String
		
		Dim fan As FieldAttributesN
		
		fan.Initialize
		fan=TableWheres.Get(i)
		
		fieldName = fan.fieldName
		fieldValue = fan.fieldValue
		
		If i > 0 Then
			wheres.Append(" AND ")
		End If
		' update member set mem_name='123'  where mem_no='a001'
		wheres.Append(EscapeField(fieldName))
		wheres.Append($"='${fieldValue}' "$ )
		
	Next
	
	'Log("3")
	'
	Dim lc_sqlCommand As String
	
	lc_sqlCommand = $"UPDATE ${EscapeField(TableName)} SET ${columns.ToString} WHERE ${wheres.ToString} "$

	Return lc_sqlCommand
End Sub


private Sub SQLBuilder_Delete() As String
	Dim sb, columns, wheres As StringBuilder
	
	sb.Initialize
	columns.Initialize
	wheres.Initialize

	'WHERE	
	For i=0 To TableWheres.Size-1
		'Log("2")
		
		Dim fieldName As String
		Dim fieldValue As String
		
		Dim fan As FieldAttributesN
		
		fan.Initialize
		fan=TableWheres.Get(i)
		
		fieldName = fan.fieldName
		fieldValue = fan.fieldValue
		
		If i > 0 Then
			wheres.Append(" AND ")
		End If
 
		wheres.Append(EscapeField(fieldName))
		wheres.Append($"='${fieldValue}' "$ )
		
	Next
	
	'Log("3")
	'
	Dim lc_sqlCommand As String
	
	lc_sqlCommand = $"DELETE FROM ${EscapeField(TableName)} WHERE ${wheres.ToString} "$

	Return lc_sqlCommand
End Sub


private Sub SQLBuilder_Query() As String
	Dim sb, columns, wheres As StringBuilder
	
	sb.Initialize
	columns.Initialize
	wheres.Initialize

	'Fields
	For i=0 To TableFields.Size-1
		'Log("1")
		
		Dim fieldName As String
		 
		
		Dim fan As FieldAttributesN
		
		fan.Initialize
		fan=TableFields.Get(i)
		
		fieldName = fan.fieldName
		 
		
		If i > 0 Then
			columns.Append(", ")
		End If
 
		columns.Append(EscapeField(fieldName))
 		
	Next
	
	Dim lc_field As String = ""
	
	If TableFields.Size = 0 Then
		lc_field = "*"
	Else	
		lc_field = columns.ToString
	End If

	'WHERE	
	For i=0 To TableWheres.Size-1
		'Log("2")
		
		Dim fieldName As String
		Dim fieldValue As String
		
		Dim fan As FieldAttributesN
		
		fan.Initialize
		fan=TableWheres.Get(i)
		
		fieldName = fan.fieldName
		fieldValue = fan.fieldValue
		
		If i > 0 Then
			wheres.Append(" AND ")
		End If
 
		wheres.Append(EscapeField(fieldName))
		wheres.Append($"='${fieldValue}' "$ )
		
	Next
	
	Dim lc_where As String = ""
	
	If TableWheres.Size = 0 Then
		lc_where = " "
	Else	
		lc_where = $" WHERE ${wheres.ToString} "$
	End If
	
	'
	Dim lc_sqlCommand As String
	
	lc_sqlCommand = $"SELECT ${lc_field} FROM ${EscapeField(TableName)}  ${lc_where} "$

	Return lc_sqlCommand
End Sub

public Sub AddCommand(cmd As String) 
	Dim s As SQLCommand
	
	s.Initialize 
	s.Command = cmd
	
	SQLCommands.Add(s)
End Sub

public Sub AddCommand2(cmd As String, params() As Object)
	Dim s As SQLCommand
	
	s.Initialize
	s.Command = cmd
	s.Parameters = params
	
	SQLCommands.Add(s)
End Sub


public Sub ExecuteCommands() As  Boolean
	Log("DBConnect ExecuteCommands==>")
	Dim SQL As SQL
 

	'SQL連線給定
	Select uc_DB_Type.ToUpperCase
		Case "MYSQL"
			SQL=MySQL
		Case "MSSQL"
			SQL=MSSQL
		Case "SQLITE"
			SQL=SQLite
		Case "FIREBIRD"
			SQL=Firebird
		Case Else
			Log("ExecuteCommands.err")
	End Select

	SQL.BeginTransaction				'交易開始
	'
	Try
		For Each cmd As SQLCommand In SQLCommands
			Dim pa() As Object

			If pa = Null Then
				pa= Array()
			Else
				pa=cmd.Parameters
			End If
			Log("Command: "&cmd.Command)
			
			SQL.ExecNonQuery2(cmd.Command ,pa)
			
		Next
		SQL.TransactionSuccessful	'交易成功
		
	Catch
		SQL.Rollback				'交易失敗
		'Log(LastException)
		LastError = LastException
		
		Return False
	End Try

	Return True
End Sub

public Sub ExecuteQuery() As  Boolean
	Log("DBConnect ExecuteQuery==>")
	Dim SQL As SQL
 

	'SQL連線給定
	Select uc_DB_Type.ToUpperCase
		Case "MYSQL"
			SQL=MySQL
		Case "MSSQL"
			SQL=MSSQL
		Case "SQLITE"
			SQL=SQLite
		Case "FIREBIRD"
			SQL=Firebird
		Case Else
			Log("ExecuteQuery.err")
	End Select

	If SQLCommands.Size = 0 Then
		LastError = "SQL Command is Null"
		
		Return False
	End If
	'
	Try
		Dim i As Int =0
		For Each cmd As SQLCommand In SQLCommands
			Dim pa() As Object

			If pa = Null Then
				pa= Array()
			Else
				pa=cmd.Parameters
			End If
			
			DBResultSet = SQL.ExecQuery2(cmd.Command ,pa)
 			
			i=i+1
			If i=1 Then			'只執行第一個
				Exit
			End If
	
		Next
		
'		
'		For i=0 To SQLCommands.Size-1				
'			Dim s As SQLCommand
'			Dim cmd As String
'			Dim pa() As Object
'			s.Initialize
'			s=SQLCommands.Get(i)
'			
'			cmd=s.Command
'			pa=s.Parameters
'			
'			If pa = Null Then
'				pa= Array()
'			End If
' 
'			DBResultSet = SQL.ExecQuery2(cmd,pa)
' 
'			If i=0 Then			'只執行第一個
'				Exit
'			End If
'		Next

	Catch
		'Log(LastException)
		LastError = LastException
		
		Return False
	End Try

	Return True
End Sub

	
public Sub SQLExec(lc_sqlCommand As String) As  Boolean
	Log("DBConnect SQLExec==>")
	Dim SQL As SQL
 

	'SQL連線給定
	Select uc_DB_Type.ToUpperCase
		Case "MYSQL"
			SQL=MySQL
		Case "MSSQL"
			SQL=MSSQL
		Case "SQLITE"
			SQL=SQLite
		Case "FIREBIRD"
			SQL=Firebird
		Case Else
			Log("SQLExec.err")
	End Select
	'	
	If lc_sqlCommand.Length = 0 Then
		LastError = "sqlCommand Null"
		Return False
	End If
	'
	Try
		If CommandType = "QUERY" Then
			DBResultSet = SQL.ExecQuery(lc_sqlCommand)
		Else
			SQL.ExecNonQuery(lc_sqlCommand)	
		End If
		
	Catch
		'Log(LastException)
		LastError = LastException
		Return False
	End Try
	Return True
End Sub


Public Sub ExecuteTableView(TableView1 As TableView) As ResumableSub
	Log("DBConnect ExecuteTableView==>")
	
	Dim Result As Int = -1
	
 
	
	
	TableView1.Items.Clear
	
	Dim Cursor As ResultSet = DBResultSet
 
	'Cursor.ColumnCount
	Do While Cursor.NextRow
 		Dim values(2) As String
		
		values(0) = Cursor.GetString("mem_no")
		values(1) = Cursor.GetString("mem_name")
		
		TableView1.Items.Add(values)
		
		Result = 1
	Loop
	
'	
'	If res <> Null And res.IsInitialized Then
'		Dim cols As List
'		cols.Initialize
'		For i = 0 To res.Columns.Size -1
'			cols.Add(res.Columns.GetKeyAt(i))
'		Next
'		TableView1.SetColumns(cols)
'		For Each row() As Object In res.Rows
'			Dim values(res.Columns.Size) As String
'			Dim value As String
'			For col = 0 To res.Columns.Size - 1
'				value = row(col)
'				values(col) = value
'			Next
'			TableView1.Items.Add(values)
'		Next
'		Result = res.Rows.Size
'	End If
	Return Result
End Sub